commit 003527e70e4e2d8b55e1ffe453399ca579860449
Author: freddy77 <freddy77>
Date:   Thu Jun 5 16:21:50 2008 +0000

    fix some SQLFetch/SQLFetchScroll issues

diff --git a/ChangeLog b/ChangeLog
index f1fb9c4..49e1eb2 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Thu Jun 05 18:21:25 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c:
+	- fix cursor6 test
+	- SQLFetch odbc 2 compliant
+
 Thu Jun 05 18:08:29 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/cursor6.c(added):
 	- added new test
@@ -328,4 +333,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2531 2008/06/05 16:08:46 freddy77 Exp $
+$Id: ChangeLog,v 1.2532 2008/06/05 16:21:50 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 3f4f497..a69da4f 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.480 2008/04/29 15:08:56 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.481 2008/06/05 16:21:54 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -3670,10 +3670,6 @@ _SQLFetch(TDS_STMT * stmt, SQLSMALLINT FetchOrientation, SQLLEN FetchOffset)
 					truncated = 1;
 					stmt->errs.lastrc = SQL_SUCCESS_WITH_INFO;
 				}
-			} else {
-				/* TODO change when we code cursors support... */
-				/* stop looping, forward cursor support only one row */
-				num_rows = 1;
 			}
 			if (drec_ard->sql_desc_octet_length_ptr)
 				*AT_ROW(drec_ard->sql_desc_octet_length_ptr, SQLLEN) = len;
@@ -3710,11 +3706,33 @@ _SQLFetch(TDS_STMT * stmt, SQLSMALLINT FetchOrientation, SQLLEN FetchOffset)
 SQLRETURN ODBC_API
 SQLFetch(SQLHSTMT hstmt)
 {
+	SQLRETURN ret;
+	SQLULEN  save_sql_desc_array_size;
+	SQLULEN *save_sql_desc_rows_processed_ptr;
+	SQLUSMALLINT *save_sql_desc_array_status_ptr;
+
 	INIT_HSTMT;
 
 	tdsdump_log(TDS_DBG_FUNC, "SQLFetch(%p)\n", hstmt);
 
-	ODBC_RETURN(stmt, _SQLFetch(stmt, SQL_FETCH_NEXT, 0));
+	if (stmt->dbc->env->attr.odbc_version != SQL_OV_ODBC3) {
+		save_sql_desc_array_size = stmt->ard->header.sql_desc_array_size;
+		stmt->ard->header.sql_desc_array_size = 1;
+		save_sql_desc_rows_processed_ptr = stmt->ird->header.sql_desc_rows_processed_ptr;
+		stmt->ird->header.sql_desc_rows_processed_ptr = NULL;
+		save_sql_desc_array_status_ptr = stmt->ird->header.sql_desc_array_status_ptr;
+		stmt->ird->header.sql_desc_array_status_ptr = NULL;
+	}
+
+	ret = _SQLFetch(stmt, SQL_FETCH_NEXT, 0);
+
+	if (stmt->dbc->env->attr.odbc_version != SQL_OV_ODBC3) {
+		stmt->ard->header.sql_desc_array_size = save_sql_desc_array_size;
+		stmt->ird->header.sql_desc_rows_processed_ptr = save_sql_desc_rows_processed_ptr;
+		stmt->ird->header.sql_desc_array_status_ptr = save_sql_desc_array_status_ptr;
+	}
+
+	ODBC_RETURN(stmt, ret);
 }
 
 #if (ODBCVER >= 0x0300)

